<template>
  <div class="layout">

      <Timer 
        :count="this.interval" 
        :counterLabel="this.label" 
        :rounds="this.totalRounds" 
        :state="this.state"
      />

      <section v-if="this.state === 'neutral'" class="timesAndRoundsSelectors">
        <form>
          <!-- ROUNDS NUMBER -->
          <div class="form-input">
            <label for="roundsInput">Rounds</label>
            <input 
              @keyup="verifyInputs()" 
              v-model.number="rounds" 
              type="number" 
              id="roundsInput" 
              required 
              min="1" 
              value="1"
            />
            <p v-if="this.rounds < 1" class="hint">One round minimum</p>
          </div>

          <!-- intenseING TIME INTERVAL -->
          <div class="form-input">
            <label for="intenseInput">Intense time (seconds)</label>
            <input 
              @keyup="verifyInputs()" 
              v-model.number="intense" 
              type="number" 
              id="intenseInput" 
              required 
              min="10"
            />
            <p v-if="this.intense < 10" class="hint">10s minimum</p>
          </div>

          <!-- RESTING TIME INTERVAL -->
          <div class="form-input">
            <label for="restInput">Rest time (seconds)</label>
            <input 
              @keyup="verifyInputs()" 
              v-model.number="rest" 
              type="number" 
              id="restInput" 
              required min="10"
            />
            <p v-if="this.rest < 10" class="hint">10s minimum</p>
          </div>

          <!-- WARMING TIME INTERVAL -->
          <div class="warmingDiv">
            <label for="warming">Warming </label>
            <input v-model="warming" type="checkbox" id="warming">
            <div v-if="warming" class="form-input">
              <input 
                @keyup="verifyInputs()" 
                v-model.number="warmingUp" 
                type="number" 
                required 
                min="10"
              />
              <p v-if="this.warmingUp < 10" class="hint">10s minimum</p>
            </div>
          </div>
        </form>

        <!-- LAUNCH TIMER -->
        <button @click="start()">Go</button>
        <p v-if="formError" class="hint">Please fill with correct values</p>

      </section>

    <!-- PAUSE & STOP -->
    <div class="button-group" v-if="this.state !== 'neutral'">
      <button @click="pause()" v-if="!this.isPaused" class="pause">Pause</button>
      <button @click="start()" v-if="this.isPaused" class="pause">Resume</button>
      <button @click="kill()" class="stop">Stop</button>
    </div>
    
    <audio src="../assets/bip.mp3" ref="bip"></audio>
  </div>
</template>

<script>
import Timer from './Timer'

export default {
    name: 'Layout',
    components: {
        Timer
    },
    data: () => {
        return {
            intense: 10,
            rest: 10,
            rounds: 1,
            totalRounds: 0,
            label: "Wassup ?",
            state: 'neutral',
            interval: 0,  
            counter: null,
            isPaused: true,
            temp: null,
            warming: false,
            warmingUp: 10,
            sequence: [],
            formError: false,
        }
    },
    methods: {
      // CHECK INPUTS VALUES ON EACH CHANGE
      verifyInputs() {
        if (this.intense < 10 || this.rest < 10 || this.rounds < 1 || this.warm < 10) {
          this.formError = true
        } else {
          this.formError = false
        }
      },

      // START TIMER
      start() {
        // IF VALUES ARE NOT GOOD
        if (this.intense < 10 || this.rest < 10 || this.rounds < 1 || this.warm < 10) {
          return;
        }
        this.isPaused = !this.isPaused;

        if (!this.isPaused) {
          if (this.sequence.length === 0) {
            this.sequence = this.createSequence();
          }
          this.count();
        }
      },

      // COUNTER
      count() {
        this.totalRounds = this.rounds;
        // CURRENT SEQUENCE
        const seq = this.sequence[0];

        if (this.sequence.length !== 0) {

          // PRINT DATAS
          if(this.temp) {
            this.interval = this.temp;
          } else {
            this.interval = seq.interval;
          }

          // REFRESH FRONT
          this.label = seq.label;
          this.state = seq.state;

          // RESET TEMP VARIABLE IF PAUSE
          this.temp = null;

          // REDUCE TOTAL ROUND
          if (seq.state === "rest") {
            this.rounds--;
          }

          this.counter = setInterval(() => {
            if (this.interval <= 0) {
              // PLAY SOUND BETWEEN SEQUENCES
              const bip = this.$refs.bip;
              bip.play()
              // REMOVE PASSED SEQUENCE
              this.sequence.shift();
              clearInterval(this.counter);
              // LOOP ON FUNCTION
              this.count();
              // REFRESH TEMP VARIABLE
              this.temp = null;
            } else {
              this.interval--;
            }
          }, 1000)
        } else { // IF NO MORE SEQUENCES
          this.state = 'neutral';
          this.label = 'Impressive !';
          this.interval = 0;
          this.isPaused = true;
          this.rounds = 1;
          if (seq.state === 'rest') {
            seq.totalRounds--;
          }
          clearInterval(this.counter);
        }
      },

      // CREATE SEQUENCE BEFORE STARTING TIMER
      createSequence() {
          // INTENSE TIME INTERVAL
          const intenseSequence = { 
              interval: this.intense,
              state: 'intense',
              label: 'Intense !',
          }
          // RESTING TIME INTERVAL
          const restSequence = {
              interval: this.rest,
              state: 'rest',
              label: 'Resting time !',
          }
          // WARMING UP INTERVAL
          const warmingSequence = {
              interval: this.warmingUp,
              state: 'warm',
              label: 'Warming up !'
          }
          // WORK SEQUENCE (INTENSE + REST & OPTIONAL WARMING UP)
          const workSequence = []
          for(let i = 0; i < this.rounds; ++i) {
              workSequence.push(intenseSequence)
              workSequence.push(restSequence)
          }
          // IF WARMING UP
          if(this.warming) {
              workSequence.push(warmingSequence)
              workSequence.splice(0, 0, warmingSequence)
          }
          return workSequence;
      },

      // PAUSE SEQUENCE
      pause() {
        this.temp = this.interval;
        this.isPaused = true;
        clearInterval(this.counter);
      },

      // KILL THE APP
      kill() {
        this.state = 'neutral';
        this.isPaused = true;
        this.temp = null;
        this.label = 'Wassup ?';
        this.interval = 0;
        clearInterval(this.counter);
      }
    }
}
</script>

<style lang="scss" scoped>
    @import './Layout';
</style>